## 运行流程

### 最简模型

1. 接收到web请求，引入`yl.js`主文件，建立基本架构
2. 引入`onLoad.js`文件，注册`onload`事件响应函数
3. 读取`basic`存档数据，并以此发起系统初始化
4. 系统读取所需资源，完成初始化，渲染桌面
5. 响应用户操作

### 高级应用

最简模型往往不能满足我们的需求。定制化改动推荐实现于`YL.onLoad`函数（位于onLoad.js）。

例如，我们希望存档数据来源于网络，而不是固定值，则可以用以下代码实现

~~~javascript
YL.onLoad(function () {
	var getDataFromServer=function(){
    	//由自己实现，从远程获取存档数据，如ajax、jsonp
    }
	var data=getDataFromServer(); 
	YL.init(data);
    console.log('正在加载数据');
}
~~~

> 在之后的文档中我们将学习存档数据的结构，它是整个框架的核心。



又或者我们希望用户在加载完桌面后，通过登录账号，自己选择存档数据，则需要相关API的配合。