## 全局配置
全局配置文件定义于根目录下`configs.js`文件，它决定了整个系统的基本属性，原则上来说不推荐频繁修改。

>其中 `lockedApps` 和 `trustedApps` 一定要认真按需填写。如果信任了有害的APP，可能会侵犯用户利益。

| 属性名                 | 说明                                                         | 默认值                                                   |
| ---------------------- | ------------------------------------------------------------ | -------------------------------------------------------- |
| softwareName           | 项目名，展示到关于界面                                       | ‘YLUI示例网站’                                           |
| version                | 项目版本                                                     | ’1.0.0‘                                                  |
| lang                   | 界面语言，设为auto可自动判断                                 | ’zh-cn‘                                                  |
| iconBtnStart           | 主要图标，取自font-awesome                                   | ‘html5’                                                  |
| author                 | 作者签名                                                     | ‘null’                                                   |
| contactInformation     | 作者联系方式                                                 | ‘null’                                                   |
| officialWebsite        | 项目官网                                                     | ‘null’                                                   |
| welcome                | 控制台欢迎信息                                               | ’null‘                                                   |
| copyrightDetail        | 版权声明                                                     | ‘null’                                                   |
| otherStatements        | 其他信息，展示到关于界面                                     | ’‘                                                       |
| authorization          | 授权信息                                                     | ‘待授权’                                                 |
| serialNumber           | YLUI序列号                                                   | ‘NULL’                                                   |
| changeable             | 存档数据可变(是否开启数据可视化变更)                         | true                                                     |
| dataCenter             | 是否展示数据管理中心                                         | true                                                     |
| localStorageName       | 浏览器存储字段名，建议保留默认                               | ’ylui-storage‘                                           |
| lockedApps             | 锁定应用列表，被锁定应用不会被覆盖或卸载                     | ['yl-system','yl-color-picker','yl-browser','yl-server'] |
| trustedApps            | 可信应用列表，被信任应用有更高的操作权限                     | ['yl-server‘]                                            |
| debug                  | 调试模式，开启后有更多调试信息                               | true                                                     |
| beforeOnloadEnable     | 离开页面时询问                                               | true                                                     |
| WarningPerformanceInIE | IE下提示体验不佳                                             | true                                                     |
| languages              | 语言数据，语言数据会根据语言配置，从文件自动加载，如需扩展请模仿默认语言文件添加 | {}                                                       |