## 全局API

### YL.init(data)

*data object|null 待加载的数据*

初始化 YLUI。如果data不存在，YLUI将尝试用空数据启动。

### YL.import(data)

*data object 待加载的数据*

重新加载 YLUI。

### YL.export()

*return object*

返回当前数据存档对象。

### YL.lang(key)

*key string 语言字段*

返回对应字段的语言数据。语言请参考文件`langs/zh-cn.json`。

### YL.reset()

将YLUI转变为空数据状态。

### YL.msg(title,content)

*title string 标题*

*content string 正文*

推送一个消息。

### YL.open(appId,options)

*appId string|object 应用的id或应用数据*

*options object 覆盖应用数据的键值对*

*return string 窗口id*

打开一个窗口。如果appId为object，表示appId为一个APP的json数据结构，可以临时打开一个窗口而不依赖已有的APP。

### YL.aboutUs()

打开关于窗口。

### YL.uninstall(appId)

*appId string 应用的id*

卸载一个应用。

### YL.addApp(appId,data)

*appId string 应用的id* 

*data object 应用的数据*

*return bool 是否成功*

添加一个APP。APP数据格式可以参考`6.3应用`的文档。

### YL.addShortcut(appId)

*appId string|object 应用的id或桌面图标数据*

添加一个桌面图标。如果appId 为string，添加对应APP的图标；如果为object，则以此为图标数据创建桌面图标。

桌面图标的数据格式可以参考`6.4桌面图标`的文档。

### YL.addMenuItem(appId)

*appId string|object 应用的id或菜单项数据* 

添加一个菜单项。如果appId 为string，添加对应APP的菜单项；如果为object，则以此为菜单项数据创建菜单项。

菜单项的数据格式可以参考`6.6开始菜单`的文档。

### YL.addSidebarBtn(appId)

*appId string|object 应用的id或侧边栏图标数据*

添加一个侧边栏图标。如果appId 为string，添加对应APP的侧边栏图标；如果为object，则以此为侧边栏图标数据创建侧边栏图标。

侧边栏图标的数据格式可以参考`6.6开始菜单`的文档。

### YL.addTile(appId, n)

*appId string|object 应用的id或磁贴数据*

*n int 磁贴组位置，默认为0（第一组）*

添加一个磁贴。如果appId 为string，添加对应APP的磁贴；如果为object，则以此为磁贴数据创建磁贴。

磁贴的数据格式可以参考`6.5磁贴`的文档。

### YL.addTileGroup(groupTitle)

*groupTitle string|null 磁贴组的标题* 

*return int 磁贴组位置*

添加磁贴组，返回添加后的位置。

### YL.setThemeColor(color)

*color string 颜色* 

设置主题色。

### YL.setWallpaper(urlImg)

*urlImg string 壁纸图片的url* 

设置壁纸。

### YL.debug(log)

*log mixed 打印的内容*

在debug模式下打印内容。

### YL.onLoad(cb)

*cb function 函数*

YLUI加载前将调用cb。此API可以被多次调用。

### YL.onReady(cb)

*cb function 函数*

`YL.init()`完毕后将调用cb。此API可以被多次调用。

### YL.f5()

重载网页。

-----------------------------------

### YL.util.isTrustedApp(id)

*appId string 应用的id*

*return bool*

应用是否是被信任的。

### YL.util.simpleMsg(msg)

*msg string 消息内容*

弹出一个消息框。

### YL.util.simpleConfirm(msg, cb)

*msg string 消息内容*

*cb function 回调函数*

弹出一个确认框。

### YL.util.getID()

*return int*

返回一个不重复的数字（递增）。

### YL.util.getRandomColor()

*return string*

返回一个随机颜色。

### YL.util.getAppDataTemplate()

*return object*

返回一个APP数据模板。

### YL.util.enableFullScreen()

进入全屏。

### YL.util.disableFullScreen()

退出全屏。
